/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service5 which has a Callback
 * interface which is implemented by this class
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "..\general\Service1.h"
#include "Service5Callback.h"
#include "Service5Proxy.h"
#include <string>

class Service1Callback5Impl : public Service1, Service5Callback {
public:
	// @Property
	std::string serviceName;

	// @Reference(interfaceHeader="Service5.h")
	Service5ProxyPtr reference1;

	Service1Callback5Impl();
	virtual ~Service1Callback5Impl();

	virtual std::string operation1(const std::string input);

	virtual std::string callback1(const std::string input);

};
