/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service1
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service5Impl2.h"
#include "..\ComponentContext.h"
#include "..\SDO.h"
using namespace oasis::sca;

// Construction/Destruction

Service5Impl2::Service5Impl2()
{
	repeatCount = 3;
	
	ComponentContextPtr context = ComponentContext::getCurrent();

	DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");
	
	return;
}


Service5Impl2::~Service5Impl2()
{
	return; 
}

// Implementation

std::string Service5Impl2::operation1(const std::string input) {
	std::string callbackResult = "";

	ComponentContextPtr context = ComponentContext::getCurrent();
	ServiceReferencePtr serviceRef = context->getSelfReference();
	ServiceProxyPtr callback = serviceRef->getCallback();
	callback1 = dynamicCast<Service5CallbackProxy>(callback);

	if (callback1)
		for (int i = 0; i < repeatCount; i++)
			callbackResult += " " + callback1->callback1(input);
		
	return serviceName + " operation1 invoked" + " " + callbackResult;
}
