/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service5 which has a Callback
 * interface which is implemented by this class
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1Callback6Impl.h"
#include "..\ComponentContext.h"
#include "..\SDO.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Callback6Impl::Service1Callback6Impl()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");
	
	return;
}


Service1Callback6Impl::~Service1Callback6Impl()
{
	return; 
}

// Implementation

std::string Service1Callback6Impl::operation1(const std::string input) {
	std::string result;

	ComponentContextPtr context = ComponentContext::getCurrent();

	ServiceProxyPtr service = context->getService("reference1");
	reference1 = dynamicCast<Service6Proxy>(service);

	if (reference1)
		result = reference1->operation1(input);
		
	return serviceName + " operation1 invoked" + " " + result;
}

std::string Service1Callback6Impl::callback1(const std::string input) {
	return serviceName + " callback1 invoked";
}
