/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service5 which has a Callback
 * interface which is implemented by this class
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "..\general\Service1.h"
#include "Service6Callback.h"
#include "Service6Proxy.h"
#include <string>

class Service1Callback6Impl : public Service1, Service6Callback {
public:
	// @Property
	std::string serviceName;

	// @Reference(interfaceHeader="Service6.h")
	Service6ProxyPtr reference1;

	Service1Callback6Impl();
	virtual ~Service1Callback6Impl();

	virtual std::string operation1(const std::string input);

	virtual std::string callback1(const std::string input);

};
