/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation
 * 1 service with interface Service5, which has a callback
 * 0 references
 *
 * @author Bryan Aupperle
 *
 */

#include "Service7Impl.h"
#include "..\ComponentContext.h"
#include "..\SDO.h"
using namespace oasis::sca;

// Construction/Destruction

Service7Impl::Service7Impl()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");
	
	return;
}


Service7Impl::~Service7Impl()
{
	return; 
}

// Implementation

std::string Service7Impl::operation1(const std::string input) {
	std::string callbackResult;

	ComponentContextPtr context = ComponentContext::getCurrent();
	ServiceReferencePtr serviceRef = context->getSelfReference();
	ServiceProxyPtr callback = serviceRef->getCallback();
	callback1 = dynamicCast<Service7CallbackProxy>(callback);

	if (callback1)
		callbackResult = callback1->callback1(input);
		
	return serviceName + " operation1 invoked" + " " + callbackResult;
}
