#include "refcountingpointer.h"
/*
 * Copyright(C) OASIS(R) 2006,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 */

/** @file */

#ifndef _oasis_sca_ServiceReference_h_
#define _oasis_sca_ServiceReference_h_

namespace oasis {
    namespace sca {
        
        /**
         * Defines the ServiceReference interface
         */
        class ServiceReference {
            public:
            
                /**
                 * Returns a service proxy implementing the interface defined for a ServiceReference
                 * @return Pointer to a ServiceProxy implementing the interface of the ServiceReference.
                 */ 
                virtual ServiceProxyPtr getService() const = 0;  

 
                /**
                 * Returns a service proxy implementing the callback interface defined for a ServiceReference.
                 * @return Pointer to a ServiceProxy implementing the callback interface of the ServiceReference.
                 *         This will be NULL if no callback interface is defined.
                 */ 
                virtual ServiceProxyPtr getCallback() const = 0;
        };
        
        
        /**
         * RefCounting Pointer for a ServiceReference.
         */
        typedef RefCountingPointer<ServiceReference> ServiceReferencePtr;                
                
    } // namespace sca
} // namespace oasis 

#endif /* _oasis_sca_ServiceReference_h_ */
