/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * Basic test initiation class
 * @author Bryan Aupperle
 *
 */

#import "TestInvocation.h"
#import "Service1Proxy.h"

class ASM_0001_Client : public TestInvocation {
private:
	std::string testName;

public:
	ASM_0001_Client();
	virtual ~ASM_0001_Client();

	/**
	 * This method is offered as a service and is 
	 * invoked by the test client to run the test
	 */
	virtual std::string invokeTest(const std::string input); 

	/**
	 * This method actually runs the test - and is subclassed by classes that run other tests.
	 * @param input - an input string
	 * @return - a response string = "ASM_0001 inputString invoked ok";
	 * 
	 */
	virtual std::string runTest(const std::string input);

protected:
	/**
	 * Sets the name of the test
	 * @param name - the test name
	 */
	void setTestName(const std::string name) {
		testName = name;
	};

};
