/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * Test initiation class with a single reference of multiplicity 1..1
 * @author Bryan Aupperle
 *
 */

#include "ASM_0002_Client.h"
#include "..\ComponentContext.h"
#include "..\SCAException.h"
#include "..\SDO.h"
using namespace oasis::sca;

ASM_0002_Client::ASM_0002_Client() {
	ComponentContextPtr context = ComponentContext::getCurrent();

	DataObjectPtr properties = context->getProperties();

	std::string testName = properties->getString("testName");
	
	return;
}

ASM_0002_Client::~ASM_0002_Client()
{
	return; 
}

std::string ASM_0002_Client::invokeTest(const std::string input) {
	std::string response = "";

	try {
		response = runTest(input);
	} catch (SCAException e) {
		throw new TestException("SCA Runtime Exception", "Test service got an exception during execution: " + *e.getMessageText());
	} // end try
	return response;
} 

std::string ASM_0002_Client::runTest(const std::string input) {
	std::string response = "", response1;

	ComponentContextPtr context = ComponentContext::getCurrent();

	ServiceProxyPtr service = context->getService("reference1");
	reference1 = dynamicCast<Service1Proxy>(service);

	if (reference1)
		response1 = reference1->operation1(input);

	response = testName + " " + input + " " + response1;

	return response;
}
