/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * Test initiation class with a single reference of multiplicity 1..1
 * @author Bryan Aupperle
 *
 */

#include "ASM_0003_Client.h"
#include "..\ComponentContext.h"
#include "..\SDO.h"
using namespace oasis::sca;

ASM_0003_Client::ASM_0003_Client() {
	ComponentContextPtr context = ComponentContext::getCurrent();

	DataObjectPtr properties = context->getProperties();

	std::string testName = properties->getString("testName");
	
	return;
}

ASM_0003_Client::~ASM_0003_Client()
{
	return; 
}

std::string ASM_0003_Client::invokeTest(const std::string input) {
	std::string response = "";

	response = runTest(input);

	return response;
} 

std::string ASM_0003_Client::runTest(const std::string input) {
	std::string response = "", response1;

	ComponentContextPtr context = ComponentContext::getCurrent();

	std::vector<ServiceProxyPtr> service = context->getServices("reference1");

	reference1.clear();	
	Service1ProxyPtr reference;
	for(int i = 0; i < service.size(); i++) {
    		
		reference = dynamicCast<Service1Proxy>(service[i]);
		if (reference) {
			reference1[i] = reference;
			response += reference1[i]->operation1(input);
		}
    }

	response = testName + " " + input + " " + response1;

	return response;
}
