/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * Test initiation class header with a single reference of multiplicity 1..1
 * @author Bryan Aupperle
 *
 */

#import "TestInvocation.h"
#import "Service1Proxy.h"
#include <vector>

class ASM_0003_Client : public TestInvocation {
public:
	// @Property
	std::string testName;

	// @Reference(interfaceHeader="Service1.h")
	std::vector<Service1ProxyPtr> reference1;

	ASM_0003_Client();
	virtual ~ASM_0003_Client();

	/**
	 * This method is offered as a service and is 
	 * invoked by the test client to run the test
	 */
	virtual std::string invokeTest(const std::string input); 

	/**
	 * This method actually runs the test - and is subclassed by classes that run other tests.
	 * @param input - an input string
	 * @return - a response string = "ASM_0001 inputString invoked ok";
	 * 
	 */
	virtual std::string runTest(const std::string input);

protected:
	/**
	 * Sets the name of the test
	 * @param name - the test name
	 */
	void setTestName(const std::string name) {
		testName = name;
	};

};
