/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service1
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "Service1Proxy.h"
#include <string>

class Service1Impl2 : public Service1 {
public:
	// @Property
	std::string serviceName;

	// Reference with an implied multiplicity of (1..1) since required=true is the default
	// @Reference(interfaceHeader="Service1.h")
	Service1ProxyPtr reference1;

	Service1Impl2();
	virtual ~Service1Impl2();

	virtual std::string operation1(const std::string input);

};
