/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1
 * 1 reference (1..n) with interface Service1
 * all configured wires get called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl3.h"
#include "..\ComponentContext.h"
#include "..\SDO.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Impl3::Service1Impl3()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");
	
	return;
}


Service1Impl3::~Service1Impl3()
{
	return; 
}

// Implementation

std::string Service1Impl3::operation1(const std::string input) {
	std::string result;

	ComponentContextPtr context = ComponentContext::getCurrent();

	std::vector<ServiceProxyPtr> service = context->getServices("reference1");

	reference1.clear();	
	Service1ProxyPtr reference;
	for(int i = 0; i < service.size(); i++) {
    		
		reference = dynamicCast<Service1Proxy>(service[i]);
		if (reference) {
			reference1[i] = reference;
			result.append(reference1[i]->operation1(input));
		}
    }
    
	return serviceName + " operation1 invoked" + " " + result;
}
