/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1
 * 1 reference (1..n) with interface Service1
 * all configured wires get called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "Service1Proxy.h"
#include <string>
#include <vector>

class Service1Impl3 : public Service1 {
public:
	// @Property
	std::string serviceName;

	// Required = true + a list -> multiplicity 1..n
	// @Reference(interfaceHeader="Service1.h" required="true")
	std::vector<Service1ProxyPtr> reference1;

	Service1Impl3();
	virtual ~Service1Impl3();

	virtual std::string operation1(const std::string input);

};
