/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1
 * 0 references
 * 3 properties
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl5.h"
#include "..\ComponentContext.h"
#include "..\SDO.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Impl5::Service1Impl5()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");
	serviceData1 = properties->getString("serviceData1");
	serviceData2 = properties->getString("serviceData2");
	
	return;
}


Service1Impl5::~Service1Impl5()
{
	return; 
}

// Implementation

std::string Service1Impl5::operation1(const std::string input) {
	return serviceName + " operation1 invoked" + serviceData1 + serviceData2;
}
