/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1
 * 1 reference (0..1) with interface Service1
 * configured wire gets called when service1 operation1 is invoked, if present
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl6.h"
#include "..\ComponentContext.h"
#include "..\SDO.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Impl6::Service1Impl6()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");
	
	return;
}


Service1Impl6::~Service1Impl6()
{
	return; 
}

// Implementation

std::string Service1Impl6::operation1(const std::string input) {
	std::string result;

	result = serviceName + " operation1 invoked";

	ComponentContextPtr context = ComponentContext::getCurrent();

	ServiceProxyPtr service = context->getService("reference1");
	if (service) {
		reference1 = dynamicCast<Service1Proxy>(service);

		if (reference1)
			result.append(reference1->operation1(input));
	}
		
	return result;
}
