/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1
 * 1 reference (0..1) with interface Service1
 * configured wire gets called when service1 operation1 is invoked, if present
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "Service1Proxy.h"
#include <string>

class Service1Impl6 : public Service1 {
public:
	// @Property
	std::string serviceName;

	// Required = false -> multiplicity 0..1
	// @Reference(interfaceHeader="Service1.h" required="false")
	Service1ProxyPtr reference1;

	Service1Impl6();
	virtual ~Service1Impl6();

	virtual std::string operation1(const std::string input);

};
