/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service1
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl7.h"
#include "..\ComponentContext.h"
#include "..\SDO.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Impl7::Service1Impl7()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");
	
	return;
}


Service1Impl7::~Service1Impl7()
{
	return; 
}

// Implementation

std::string Service1Impl7::operation1(const std::string input) {
	std::string result, parameter = input;

	ComponentContextPtr context = ComponentContext::getCurrent();

	ServiceProxyPtr service = context->getService("reference1");
	reference1 = dynamicCast<Service4Proxy>(service);

	if (reference1) {
		result = reference1->operation1(parameter);
		if (input != parameter)
			return serviceName + "input parameter modified!!";
	}
	
	return serviceName + " operation1 invoked" + " " + result;
}
