/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service1
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "Service4Proxy.h"
#include <string>

class Service1Impl7 : public Service1 {
public:
	// @Property
	std::string serviceName;

	// Required = false -> multiplicity 0..1
	// @Reference(interfaceHeader="Service1.h" required="false")
	Service4ProxyPtr reference1;

	Service1Impl7();
	virtual ~Service1Impl7();

	virtual std::string operation1(const std::string input);

};
