/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/*
 * Exception thrown by SCA Test services
 * @author Bryan Aupperle
 *
 */

#include <string>

// @WebFault(name="TestException", targetNamespace="http://oasis/tests")
class TestException {
public:
	/**
	 * Constructor with fault message and fault info arguments
	 * @param message - fault message as a string
	 * @param faultInfo - fault info as a std::string
	 */
	TestException(const char* message, const std::string& faultInfo);

	/**
	 * Member function for retrieving fault info
	 * @return - fault info as a std::tring
	 */
	std::string getFaultInfo() const;

};
